; Debugging scheme programs...

(provide 'debug)

(define **debug** 1)

;;;;;;;;;;;;;;;;;;;;; Error messages and error handling ;;;;;;;;;;;;;;;;;;;;;


(define (*****) (ERROR "Ran into an implemented object"))

(define (throw-mismatch) (ERROR "Mismatch failure"))

(define (ASSERT predicate object . rest)
  (if (predicate object)
      object
      (let ((errmsg (if (pair? rest) (car rest) "Object failed assertion :")))
	(ERROR errmsg predicate object))))

;example use:
; (assert zero? 1 "Go you do see !")

; (print "Done loading lib.scm")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define error-output-port (current-output-port))

(define (error-display s)
   (display s error-output-port))

(define (debug-display s)
   (if **debug** (error-display s)))

(define (ERROR . rest)
   (error-display "Error: ")
   (write rest error-output-port)
   (error-display "\n")
   (reset))

