;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;; Scheme support macros for Tunes ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(provide 'macrolib)
(require 'lib)

; Works with Elk:
; macros are an-hygienic source-to-source functions

(define-macro (map-macro form mac . lst)
   (if (null? lst) form
      `(map-macro ,(append form `((,mac ,(car lst)))) ,mac ,@(cdr lst))))
; Example:
; (map-macro (begin) print 1 2 3 4 5)


(define-macro (curry-macro mac . args)
   `(macro x `(,,mac ,,@args ,@x)))

(define-macro (fun-sym-val fun name)
      `(,fun ',name ,name))


(define-macro (Comment XXX)
  ;(Annotate! (Current-Object) 'Comment XXX)
  '#f)




;(define-macro (def-cxxxr string)
;   (let (((cxr-name x) (make-symbol "c" x "r"))
;         ((cxr-fun x l arg)
;	    (if (eqv? l (string-length x)) arg
;	       `( ,(cxr-name (string-ref x l)) ,(cxr-fun x (1+ l) arg)))))
;    `(define (,(cxr-name string) x) ,(cxr-fun string 0 'x))))

;(map-macro (begin) def-cxxxr
;   "aa" "aaa" "aaaa" "daaa"
;        "daa" "adaa" "ddaa"
;   "da" "ada" "aada" "dada"
;        "dda" "adda" "ddda"
;   "ad" "aad" "aaad" "daad"
;        "dad" "adad" "ddad"
;   "dd" "add" "aadd" "dadd"
;        "ddd" "addd" "dddd")
