(provide 'object)
(require 'lib)


"
* An object in Tunes is just a local scope.
* It needs not have personal or shared state,
 though this can be trivially achieved by having objects with such
 attributes in the scope
* So that it can be statically compiled,
 the symbols imported from an object should be statically known.
* An OMOS-like mechanism for managing objects exists
 (merging objects, renaming symbols, etc).


* To define an object:
   (define x (make-object
      (member:
      (letrec x
         ()
* To merge objects:
* To use a method:

"


;;;;; trivial object system

(define (tos:get-member obj member)
    (syntenv:find obj member
        (lambda (f) (cadr f))
	(lambda () (error "Unknown member" obj member))))

(define (tos:send-message obj msg . rest)
    (apply (tos:get-member obj msg) rest))

;(define (: . rest)
;  (cond ((null? rest) (current-environment))
;        ((null? (cdr rest)) (
;        (else (: with-environment (car rest)

(define :<-: tos:send-message)


;;;;; A few objects

(define (new-deq)
    (let ((obj (deq:new)))
    `((->list	,(lambda () (deq:->list obj)))
      (empty?	,(lambda () (deq:empty? obj)))
      (front	,(lambda () (deq:front obj)))
      (push!	,(lambda (x) (deq:push! obj x)))
      (pop!	,(lambda () (deq:pop! obj)))
      (rear	,(lambda () (deq:rear obj)))
      (queue!	,(lambda (x) (deq:queue! obj x)))
      (unqueue!	,(lambda () (deq:unqueue! obj))))))


;;;;;

(define (new-object-definer)
    (let ((obj (deq:new)))
    `((add
         ,(lambda (member value)
	      (deq:push! obj (list member value))))
      (close
         ,(lambda () (deq:->list obj))))))

;(define-macro (make-object-macro obj . descript)
;   (let ((object (new-object-definer)))
;       (make-object
;	  (lambda (x)
;	     (


